using UnityEngine;
using System.Collections;

public class CameraCollision : MonoBehaviour {

	public float minDistance = 1.0f;
	public float maxDistance = 4.0f;
	public float smooth = 10.0f;
	public Transform target;
	
	public float heightDamping = 2.0f;
	public float rotationDamping = 3.0f;

	private float currentRotationAngle;
	
	Vector3 dollyDir;
	float distance; 

	void Awake()
	{
	    dollyDir = (target.position-transform.position).normalized;
	    distance = (target.position-transform.position).magnitude-0.5f;

		currentRotationAngle = target.eulerAngles.y;
	}

	void Update()
	{		
			float wantedRotationAngle = target.eulerAngles.y;
			currentRotationAngle = Mathf.LerpAngle (currentRotationAngle, wantedRotationAngle, rotationDamping * Time.deltaTime);
			Quaternion currentRotation = Quaternion.Euler (0, currentRotationAngle, 0);
		
			//transform.position=Vector3.Lerp(transform.position, dollyDir * distance, Time.deltaTime * smooth); 

			Vector3 targetPosition = target.position;
			targetPosition -= currentRotation * dollyDir * distance;

//			Vector3 desiredCameraPos = target.TransformPoint( dollyDir * distance );
	
   	     	RaycastHit hit;
   	     	
   	     	if( Physics.Linecast( target.position, targetPosition, out hit,1<<8 ) )
   	     	{
   	     		//recalculate
   	     	    distance = Mathf.Clamp( hit.distance, minDistance, maxDistance )-0.5f;
   	     	    targetPosition = target.position - currentRotation * dollyDir * distance;
   	     	}
   	     	else
   	     	{
   	     		distance=maxDistance-0.5f;
   	     	}   	     	
		
			//if renderer.active=distance<2;
			
			transform.position = Vector3.Lerp(transform.position,targetPosition,smooth);
			
// 	  		transform.position=targetPosition;
 	  		transform.LookAt (target);
	}

}
