/*
	Double sided rendering with alpha blending.
*/
Shader "Nature/Vegetation Vertex UnLit" {
 	Properties {
 		_Color ("Main Color", Color) = (1,1,1,1)
 		_MainTex ("Base (RGB) Trans. (Alpha)", 2D) = "white" { }
 	}
 
 	Category {
 		ZWrite Off
 		Cull Off
 		Alphatest Greater 0
 		Tags {Queue=Transparent}
 		Blend SrcAlpha OneMinusSrcAlpha 
 		SubShader {
 			Pass {
 				Lighting off
 				SetTexture [_MainTex] {
 					constantColor [_Color]
 					Combine texture * constant, texture * constant 
 				} 
 			}
 		} 
 	}
 }