var sound1:AudioClip;
var sound2:AudioClip;
var sound3:AudioClip;
var sound4:AudioClip;
var sound5:AudioClip;
var sound6:AudioClip;
var sound7:AudioClip;
var collect:AudioClip;
var collectsquare:AudioClip;

var player:UnityEngine.GameObject;
var playerParticles:UnityEngine.ParticleEmitter;

var sphereObject:UnityEngine.GameObject;
var cubeObject:UnityEngine.GameObject;
var compoundObject:UnityEngine.GameObject;
var torusObject:UnityEngine.GameObject;
var pyramidObject:UnityEngine.GameObject;
var arrowObject:UnityEngine.GameObject;
var crossObject:UnityEngine.GameObject;

var sphereAvatar:UnityEngine.GameObject;
var cube6Avatar:UnityEngine.GameObject;
var cube5Avatar:UnityEngine.GameObject;
var cube4Avatar:UnityEngine.GameObject;
var cube3Avatar:UnityEngine.GameObject;
var cube2Avatar:UnityEngine.GameObject;
var cube1Avatar:UnityEngine.GameObject;
var compoundAvatar:UnityEngine.GameObject;
var torusAvatar:UnityEngine.GameObject;
var pyramidAvatar:UnityEngine.GameObject;
var arrowAvatar:UnityEngine.GameObject;
var crossAvatar:UnityEngine.GameObject;

var rewardSphere : UnityEngine.GameObject;
var rewardCube : UnityEngine.GameObject;
var rewardPyramid1 : UnityEngine.GameObject;
var rewardPyramid2 : UnityEngine.GameObject;
var rewardArrow1 : UnityEngine.GameObject;
var rewardArrow2 : UnityEngine.GameObject;
var rewardArrow3 : UnityEngine.GameObject;
var rewardArrow4 : UnityEngine.GameObject;
var rewardArrow5 : UnityEngine.GameObject;
var rewardArrow6 : UnityEngine.GameObject;
var rewardArrow7 : UnityEngine.GameObject;
var rewardArrow8 : UnityEngine.GameObject;
var rewardCross1 : UnityEngine.GameObject;
var rewardCross2 : UnityEngine.GameObject;
var rewardCross3 : UnityEngine.GameObject;
var rewardCross4 : UnityEngine.GameObject;
var rewardCross5 : UnityEngine.GameObject;
var rewardTorus : UnityEngine.GameObject;
var rewardCompound : UnityEngine.GameObject;

var arrowCamera : UnityEngine.Camera;
var sphereCamera : UnityEngine.Camera;
var torusCamera : UnityEngine.Camera;
var compoundCamera : UnityEngine.Camera;
var cubeCamera : UnityEngine.Camera;
var pyramidCamera : UnityEngine.Camera;
var crossCamera : UnityEngine.Camera;

private var initPlayerRadius : float;

static var completedSphere : boolean;
static var completedCube : boolean;
static var completedCompound : boolean;
static var completedTorus : boolean;
static var completedPyramid : boolean;
static var completedArrow : boolean;
static var completedCross : boolean;

static var selected : String;

private var squareCount : int;

private var torusStateA : int;
private var torusStateB : int;
private var torusStateC : int;

private var arrowState : int;

private var crossConfiguration : Array =  [ [0,0,0,0,0],[0,0,0,0,0],[0,0,0,0,0],[0,0,0,0,0],[0,0,0,0,0] ];
private var crossSolution : Array = [ [1,1,1,1,1],[1,1,0,1,1],[1,0,0,0,1],[1,1,0,1,1],[1,1,1,1,1] ];

private var startingLocation : Vector3;
private var startingRotation : Quaternion;

private var buttonsToReset : Array;

var compoundObject1 : UnityEngine.GameObject;
var compoundObject2 : UnityEngine.GameObject;

function Start() {
	
	rewardSphere.renderer.enabled=false;
	rewardCompound.renderer.enabled=false;
	rewardCube.renderer.enabled=false;
	rewardArrow1.renderer.enabled=false;
	rewardArrow2.renderer.enabled=false;
	rewardArrow3.renderer.enabled=false;
	rewardArrow4.renderer.enabled=false;
	rewardArrow5.renderer.enabled=false;
	rewardArrow6.renderer.enabled=false;
	rewardArrow7.renderer.enabled=false;
	rewardArrow8.renderer.enabled=false;
	rewardCross1.renderer.enabled=false;
	rewardCross2.renderer.enabled=false;
	rewardCross3.renderer.enabled=false;
	rewardCross4.renderer.enabled=false;
	rewardCross5.renderer.enabled=false;
	rewardPyramid1.renderer.enabled=false;
	rewardPyramid2.renderer.enabled=false;
	rewardTorus.renderer.enabled=false;
	
	initPlayerRadius = player.GetComponent(CharacterController).radius;
	
	playerParticles.emit=false;
	completedSphere=false;
	completedCube=false;
	completedCompound=false;
	completedTorus=false;
	completedPyramid=false;
	completedArrow=false;
	completedCross=false;
	
	arrowState=-1;
	
	SetAvatar("sphere",false);	
	
	startingLocation = player.transform.position;
	startingRotation = player.transform.rotation;
}


function ChangeCrossHit(i : int, j : int, hit : boolean)
{
	crossConfiguration[i][j] = hit ? 1 : 0;

	CheckCrossConfiguration();
}

function CheckCrossConfiguration() 
{
	for (var i : int =0;i<crossConfiguration.length;i++)
	{
		for (var j : int =0;j<crossConfiguration[i].length;j++)
		{
			if (crossConfiguration[i][j]!=crossSolution[i][j])
				return;		
		}
	}
	
		
	completePuzzle("cross");	
}

function fadein(obj: UnityEngine.GameObject)
{
	obj.renderer.enabled=true;
	obj.renderer.material.color.a = 0;
    iTween.fadeTo(obj,{"alpha":0.69, "time":3, "delay":0.1});
}

function completePuzzle(s : String)
{
	Debug.Log("Puzzle complete : " + s);

	switch (s)
	{
		case "sphere":
			if (completedSphere)
				return;
				
			audio.PlayOneShot(sound1);
			player.active=false;
			
			completedSphere=true;
			fadein(rewardSphere);
			
			sphereCamera.enabled=true;
			
			yield WaitForSeconds (10);
			
			
			sphereCamera.enabled=false;
			player.active=true;
			
			break;
		case "cube":
			if (completedCube)
				return;
				
				
			audio.PlayOneShot(sound2);
			
			completedCube=true;
			fadein(rewardCube);
			
			
			cubeCamera.enabled=true;
			
			yield WaitForSeconds (10);
			
			
			cubeCamera.enabled=false;
			player.active=true;
			
			
			break;
		case "compound":
			if (completedCompound)
				return;
				
				
			audio.PlayOneShot(sound3);
			
			completedCompound=true;
			fadein(rewardCompound);
			compoundObject1.active=false;
			compoundObject2.active=false;
			
			player.active=false;
			
			compoundCamera.enabled=true;
			
			yield WaitForSeconds (10);
			
			
			compoundCamera.enabled=false;
			player.active=true;
			
			break;
		case "torus":
			if (completedTorus)
				return;
				
				
			audio.PlayOneShot(sound4);
			
			completedTorus=true;
			fadein(rewardTorus);
			
			player.active=false;
			
			torusCamera.enabled=true;
			
			yield WaitForSeconds (10);
			
			
			torusCamera.enabled=false;
			player.active=true;
			
			
			break;
		case "pyramid":
			if (completedPyramid)
				return;
				
				
			audio.PlayOneShot(sound5);
			
			completedPyramid=true;
			
			fadein(rewardPyramid1);
			fadein(rewardPyramid2);
			
			player.active=false;

			pyramidCamera.enabled=true;
			
			yield WaitForSeconds (10);
			
			
			pyramidCamera.enabled=false;
			player.active=true;
			
			
			break;
		case "arrow":		
			if (completedArrow)
				return;
				
				
			audio.PlayOneShot(sound6);
			
			completedArrow=true;
			fadein(rewardArrow1);
			fadein(rewardArrow2);
			fadein(rewardArrow3);
			fadein(rewardArrow4);
			fadein(rewardArrow5);
			fadein(rewardArrow6);
			fadein(rewardArrow7);
			fadein(rewardArrow8);
			
			player.active=false;
			
			arrowCamera.enabled=true;
			
			yield WaitForSeconds (10);
			
			
			arrowCamera.enabled=false;
			player.active=true;
			
			
			break;
		case "cross":		
			if (completedCross)
				return;
				
				
			audio.PlayOneShot(sound7);
			
			completedCross=true;
			
			fadein(rewardCross1);
			fadein(rewardCross2);
			fadein(rewardCross3);
			fadein(rewardCross4);
			fadein(rewardCross5);
			
			
			player.active=false;

			crossCamera.enabled=true;
			
			yield WaitForSeconds (10);
			
			
			crossCamera.enabled=false;
			player.active=true;
			
			break;
	}
	
	player.transform.position=startingLocation;
	player.transform.rotation=startingRotation;
	
	if (!completedSphere)
	{
		SetAvatar("sphere",true);
	}
	else if (!completedCube)
	{
		SetAvatar("cube",true);
	}
	else if (!completedTorus)
	{
		SetAvatar("torus",true);
	}
	else if (!completedPyramid)
	{
		SetAvatar("pyramid",true);
	}
	else if (!completedArrow)
	{
		SetAvatar("arrow",true);
	}
	else if (!completedCompound)
	{
		SetAvatar("compound",true);
	}
	else if (!completedCross)
	{
		SetAvatar("cross",true);
	}
	else
	{
		// the end
		Application.LoadLevel(2);
	}
	//if all complete, then...
	
	//reset state here
}

function EnterSphereZone()
{
	if (selected=="sphere")
	{
		completePuzzle("sphere");		
	}
}


function ArrowDispell()
{
	Debug.Log("Dispelling");
	if (selected=="arrow")
	{
		arrowState=0;
	}
}
function ArrowStartPoint()
{
	if (selected=="arrow")
	{
		arrowState=1;
	}
}

function ArrowEndPoint()
{
	if (arrowState==1)
	{
		completePuzzle("arrow");		
	}
}

function EnterPyramidZone()
{
	if (selected=="pyramid")
	{
		completePuzzle("pyramid");		
	}
}

function EnterCompoundZone()
{
	if (selected=="compound")
	{
		completePuzzle("compound");		
	}
}

function TorusClear()
{
	torusStateA=-1;
	torusStateB=-1;
	torusStateC=-1;
}

function TorusLevel(torusStateD : int)
{
	if (selected!="torus")
	{
		return;
	}

	if (
			(
				(torusStateB==(torusStateA+1)%3) && 
				(torusStateC==(torusStateB+1)%3) &&		
				(torusStateD==(torusStateC+1)%3)			
			)
			||
			( 
				(torusStateB==(torusStateA+2)%3) && 
				(torusStateC==(torusStateB+2)%3) &&
				(torusStateD==(torusStateC+2)%3)
			)
		)
	{
		completePuzzle("torus");	
	}
	
	torusStateA=torusStateB;
	torusStateB=torusStateC;
	torusStateC=torusStateD;
}

function CollectSquare() : boolean
{
	if (selected=="cube")
	{
		squareCount++;
		playerParticles.Emit();		
				
		cube1Avatar.active=false;
		cube2Avatar.active=false;
		cube3Avatar.active=false;
		cube4Avatar.active=false;
		cube5Avatar.active=false;
		cube6Avatar.active=false;
		
		switch (squareCount)
		{
			case 1:
			cube5Avatar.active=true;	
			audio.PlayOneShot(collectsquare);
			break;
			case 2:
			cube4Avatar.active=true;
			audio.PlayOneShot(collectsquare);
			break;
			case 3:
			cube3Avatar.active=true;
			audio.PlayOneShot(collectsquare);
			break;
			case 4:
			cube2Avatar.active=true;
			audio.PlayOneShot(collectsquare);
			break;
			case 5:
			cube1Avatar.active=true;
			player.GetComponent(CharacterController).radius=initPlayerRadius/4;			
			audio.PlayOneShot(collectsquare);
			break;
			case 6:
			completePuzzle("cube");
			squareCount=0;
			cube5Avatar.active=true;			
			break;
		}
	
		return true;
	}
	else
	{
		return false;
	}
}

function CurrentAvatarString() : String
{
	return selected;
}


function CurrentAvatar() : UnityEngine.GameObject
{	

	switch(selected)
	{
		case "sphere":
			return sphereAvatar;
			break;
		case "torus":
			return torusAvatar;
			break;
		case "cube":
			switch (squareCount)
			{
				case 0:
					return cube6Avatar;
				case 1:
					return cube5Avatar;
				case 2:
					return cube4Avatar;
				case 3:
					return cube3Avatar;
				case 4:
					return cube2Avatar;
				default:
					return cube1Avatar;
			}
			break;
		case "compound":
			return compoundAvatar;
			break;
		case "pyramid":
			return pyramidAvatar;
			break;
		case "arrow":
			return arrowAvatar;
			break;
		case "cross":
			return crossAvatar;
			break;
	}

	return sphereAvatar;
}

function ResetItems()
{
	compoundObject1.GetComponent(Resettable).Reset();
	compoundObject2.GetComponent(Resettable).Reset();
	
	torusStateA=-1;
	torusStateB=-1;
	arrowState=0;
	
	sphereObject.active=!completedSphere;
	cubeObject.active=!completedCube;
	compoundObject.active=!completedCompound;
	torusObject.active=!completedTorus;
	pyramidObject.active=!completedPyramid;
	arrowObject.active=!completedArrow;
	crossObject.active=!completedCross;
	
	sphereAvatar.active=false;
	cube1Avatar.active=false;
	cube2Avatar.active=false;
	cube3Avatar.active=false;
	cube4Avatar.active=false;
	cube5Avatar.active=false;
	cube6Avatar.active=false;
	compoundAvatar.active=false;
	torusAvatar.active=false;
	pyramidAvatar.active=false;
	arrowAvatar.active=false;
	crossAvatar.active=false;
		
	player.GetComponent(CharacterController).radius=initPlayerRadius;
}

function Update () {
}


function SetAvatar(s : String, emit : boolean ) {
	ResetItems();

//	player.GetComponent(ParticleEmitter).SetAvatar(which);
	if (emit)
	{
		playerParticles.Emit();
		audio.PlayOneShot(collect);
	}
	
			
	switch(s)
	{
		case "sphere":
			sphereObject.active=false;
			sphereAvatar.active=true;
			selected=s;
			break;
		case "torus":
			torusObject.active=false;
			torusAvatar.active=true;
			selected=s;
			break;
		case "cube":
			cubeObject.active=false;

			switch (squareCount)
			{
				case 0:
				cube6Avatar.active=true;
				break;
				case 1:
				cube5Avatar.active=true;
				break;
				case 2:
				cube4Avatar.active=true;
				break;
				case 3:
				cube3Avatar.active=true;
				break;
				case 4:
				cube2Avatar.active=true;
				break;
				case 5:
				cube1Avatar.active=true;
				player.GetComponent(CharacterController).radius=initPlayerRadius/4;			
				break;
			}

			selected=s;
			break;
		case "compound":
			compoundObject.active=false;
			compoundAvatar.active=true;
			selected=s;
			break;
		case "pyramid":
			pyramidObject.active=false;
			pyramidAvatar.active=true;
			selected=s;
			break;
		case "arrow":
			arrowObject.active=false;
			arrowAvatar.active=true;
			selected=s;
			break;
		case "cross":
			crossObject.active=false;
			crossAvatar.active=true;
			selected=s;
			break;
	}
}